# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from hubmap_search_sdk import HubmapSearchSDK, AsyncHubmapSearchSDK

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestReindex:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @pytest.mark.skip()
    @parametrize
    def test_method_update(self, client: HubmapSearchSDK) -> None:
        reindex = client.reindex.update(
            "identifier",
        )
        assert reindex is None

    @pytest.mark.skip()
    @parametrize
    def test_raw_response_update(self, client: HubmapSearchSDK) -> None:
        response = client.reindex.with_raw_response.update(
            "identifier",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        reindex = response.parse()
        assert reindex is None

    @pytest.mark.skip()
    @parametrize
    def test_streaming_response_update(self, client: HubmapSearchSDK) -> None:
        with client.reindex.with_streaming_response.update(
            "identifier",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            reindex = response.parse()
            assert reindex is None

        assert cast(Any, response.is_closed) is True

    @pytest.mark.skip()
    @parametrize
    def test_path_params_update(self, client: HubmapSearchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `identifier` but received ''"):
            client.reindex.with_raw_response.update(
                "",
            )


class TestAsyncReindex:
    parametrize = pytest.mark.parametrize(
        "async_client", [False, True, {"http_client": "aiohttp"}], indirect=True, ids=["loose", "strict", "aiohttp"]
    )

    @pytest.mark.skip()
    @parametrize
    async def test_method_update(self, async_client: AsyncHubmapSearchSDK) -> None:
        reindex = await async_client.reindex.update(
            "identifier",
        )
        assert reindex is None

    @pytest.mark.skip()
    @parametrize
    async def test_raw_response_update(self, async_client: AsyncHubmapSearchSDK) -> None:
        response = await async_client.reindex.with_raw_response.update(
            "identifier",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        reindex = await response.parse()
        assert reindex is None

    @pytest.mark.skip()
    @parametrize
    async def test_streaming_response_update(self, async_client: AsyncHubmapSearchSDK) -> None:
        async with async_client.reindex.with_streaming_response.update(
            "identifier",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            reindex = await response.parse()
            assert reindex is None

        assert cast(Any, response.is_closed) is True

    @pytest.mark.skip()
    @parametrize
    async def test_path_params_update(self, async_client: AsyncHubmapSearchSDK) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `identifier` but received ''"):
            await async_client.reindex.with_raw_response.update(
                "",
            )
